#!/usr/bin/python

# Copyright (C) 2017
# ASTRON (Netherlands Institute for Radio Astronomy)
# P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
#
# This file is part of the LOFAR software suite.
# The LOFAR software suite is free software: you can redistribute it
# and/or modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# The LOFAR software suite is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with the LOFAR software suite. If not, see <http://www.gnu.org/licenses/>.


import logging
from lofar.messaging.RPC import RPCWrapper
from lofar.mac.config import DEFAULT_OBSERVATION_CONTROL_BUS_NAME, DEFAULT_OBSERVATION_CONTROL_SERVICE_NAME

''' Simple RPC client for Service ObservationControl2
'''

logger = logging.getLogger(__name__)


class ObservationControlRPCClient(RPCWrapper):
    def __init__(self,
                 busname=DEFAULT_OBSERVATION_CONTROL_BUS_NAME,
                 servicename=DEFAULT_OBSERVATION_CONTROL_SERVICE_NAME,
                 broker=None,
                 timeout=120):
        super(ObservationControlRPCClient, self).__init__(busname, servicename, broker, timeout=timeout)

    def abort_observation(self, sas_id):
        return self.rpc('AbortObservation', sas_id=sas_id)
